#include "jed_plugins.h"
#include <windowsx.h>
#include <fcntl.h>
#include <stdio.h>
#include <io.h>
#include "jklog.h"


//struct FAR IJEDLevel : public IUnknown
//{
// virtual HRESULT STDMETHODCALLTYPE QueryInterface(
//                                     IID FAR& riid,
//                                     LPVOID FAR* ppvObj) = 0;
// HRESULT STDMETHODCALLTYPE NSectors(void);
// virtual HRESULT STDMETHODCALLTYPE Release(void) = 0;
// virtual HRESULT STDMETHODCALLTYPE CreateInstance(
//                                     LPUNKNOWN pUnkOuter,
//                                     IID FAR& riid,
//                                     LPVOID FAR* ppvObject) = 0;
//};
//typedef struct tjedsectorrec { 
//long         flags; 
//double       ambient; 
//double       extra; 
//char         *colormap; 
//float        tint_r, tint_g, tint_b; 
//char         *sound; 
//double       snd_vol; 
//long         layer; 
//} tjedsectorrec; 

// STDMETHOD(GetSector)(THIS_ int sec, tjedsectorrec* rec, int flags) PURE;
//IJEDLevel JKMet;

tjedsectorrec *sec;
tjedthingrec tng[256];
tjedsurfacevertex vert[256];

HDC hdc;
UINT cxClient, cyClient;

IJED *curjed;
HINSTANCE DLLInstance;
int FAR PASCAL DllEntryPoint (HINSTANCE hInstance, WORD wDataSeg, WORD cbHeapSize, LPSTR lpCmdLine)
{
 DLLInstance = hInstance;
 return 1;
}

void setJEDLevelToDlg(HWND hDlg, IJED *jed)
{
// brt = GetDlgItemInt(hDlg,105,TRUE,TRUE);
// r = GetDlgItemInt(hDlg,101,TRUE,TRUE);
// g = GetDlgItemInt(hDlg,102,TRUE,TRUE);
// b = GetDlgItemInt(hDlg,103,TRUE,TRUE);
}

void setEditDlgFromJED(HWND hDlg, IJED *jed)
{
// STDMETHOD_(int,SurfaceGetVertexNum)(THIS_ int sc, int , int ) PURE;
// STDMETHOD_(int,SectorFindVertex)(THIS_ int sec, double x, double , double ) PURE;
// int i=0,found=0,need,o=0,vert;
// while (found==0 && o<jed[0].GetLevel()[0].NSectors())
// {
//  need = jed[0].GetLevel()[0].SectorNVertices(o);
//  while (i<need)
//  {
//   if (SectorGetVertex(o,vert,0,0,0)==0)
//   i=i+1;
//  }
//  o=o+1;
// }
// jed[0].GetLevel[0].GetSelectedVX(0,0,0);
// vert = 
// STDMETHOD(GetSelectedVX)(THIS_ int n, int* sc, int* ) PURE;
// int brt = vert[0].intensity, r=vert[0].r, g=vert[0].g, b=vert[0].b;
 int brt=1,r=1,g=1,b=1;
 SetDlgItemInt(hDlg,IDC_BRIGHT,brt,TRUE);
 SetDlgItemInt(hDlg,IDC_RED,r,TRUE);
 SetDlgItemInt(hDlg,IDC_GREEN,g,TRUE);
 SetDlgItemInt(hDlg,IDC_BLUE,b,TRUE);
// SetDlgItemInt(hDlg,"IDC_XPOS",vert[0].x);
// SetDlgItemInt(hDlg,"IDC_YPOS",vert[0].y);
// SetDlgItemInt(hDlg,"IDC_XPOS",vert[0].z);

}

long WINAPI _export editVertex(HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
 char str[256];
 sprintf(str, "Message: %d. Init Dialog: %d. Command: %d. Close: %d.", message, WM_INITDIALOG, WM_COMMAND, WM_CLOSE);
 MessageBox(NULL,str,"Information",MB_OK|MB_ICONINFORMATION);
 switch (message)
 {
  case WM_INITDIALOG:
   setEditDlgFromJED(hDlg, curjed);
   return 0;

  case WM_COMMAND:
   switch (GET_WM_COMMAND_ID(wParam, lParam))
   {
    case IDOK:
     setJEDLevelToDlg(hDlg, curjed);
     EndDialog(hDlg,TRUE);
     return (TRUE);
    
    case IDCANCEL:
     EndDialog(hDlg,TRUE);
     return (TRUE);
   }
   break;

  case WM_CLOSE:
   EndDialog(hDlg,TRUE);
   break;
 }
 return FALSE;
}
 
int ShowVertexEdit()
{
 DialogBox(DLLInstance,MAKEINTRESOURCE(IDD_RGBV),NULL,(DLGPROC)editVertex);
 return 1;
}

extern "C" __declspec(dllexport) bool _stdcall JEDPluginLoadStdCall(IJED* jed)
{
  char str[256];
//  MessageBox(NULL,"Press OK","TEST",MB_OK|MB_ICONSTOP);
  curjed[0]=jed[0];
  int nsecs = jed[0].GetLevel()[0].NSectors();
  int nthgs = jed[0].GetLevel()[0].NThings();
  int i=0, nsrfs=0;
  while (i<nsecs)
  {
   nsrfs = nsrfs + jed[0].GetLevel()[0].SectorNSurfaces(i);
   i=i+1;
  }
  int nlgts = jed[0].GetLevel()[0].NLights();
//  virtual HRESULT STDMETHODCALLTYPE NSectors(int) = 0;
//  HRESULT STDMETHODCALLTYPE NSectors(nsecs);
//  int nsecs = NSectors();
  sprintf(str, "There are %d sector(s), %d thing(s), %d surface(s), and %d light(s).", nsecs, nthgs, nsrfs, nlgts);
  MessageBox(NULL,str,"Information",MB_OK|MB_ICONINFORMATION);
  int nnew=0,nnosec=0;
  i=0;
  while (i<nthgs)
  {
   jed[0].GetLevel()[0].GetThing(i,tng,th_all);
   if (jed[0].FindSectorForThing(i)==-1)
    nnosec=nnosec+1;
   else
   if (jed[0].FindSectorForThing(i)!=tng[0].sector)
   {
    tng[0].sector=jed[0].FindSectorForThing(i);
    nnew=nnew+1;
   }
   jed[0].GetLevel()[0].SetThing(i,tng,th_all);
   i=i+1;
  }
  sprintf(str, "%d thing(s) layered, %d thing(s) aren't in a sector.", nnew, nnosec);
  MessageBox(NULL,str,"Information",MB_OK|MB_ICONINFORMATION);
//  if (MessageBox(NULL,"Do you want to ","Question",MB_YESNO|MB_ICONQUESTION)==IDYES)
//  {
//   int l=jed[0].GetLevel[0].GetSelectedLT(l);
   ShowVertexEdit();
//  }
//  else
//  {

//  }

//  HWND hWnd;
//  RegisterClass(const string& progid, BCID classId, bool multiUse);
//  hWnd = CreateWindow(
//   "",                 // See RegisterClass() call.
//   "Example _get_osfhandle _open_osfhandle (32 bit)",  // Text for window title bar.
//   WS_OVERLAPPEDWINDOW,        // Window style.
//   CW_USEDEFAULT,         // Default horizontal position.
//   CW_USEDEFAULT,          // Default vertical position.
//   CW_USEDEFAULT,            // Default width.
//   CW_USEDEFAULT,        // Default height.
//   NULL,                  // Overlapped windows have no parent.
//   NULL,                  // Use the window class menu.
//
//   hInstance,              // This instance owns this window.
//   NULL                   // Pointer not needed.
//  );
//  MessageBox(NULL,"Press OK","TEST",MB_OK|MB_ICONSTOP);
//  HWND  hWnd; // Main window handle.

  /* Create a main window for this application instance.  */
//  WinMain();

//int PASCAL WinMain(HINSTANCE hCurInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)

//HINSTANCE	hCurInstance 	The instance handle of the application. Each instance of an application has a
//unique instance handle. It is used as an argument to several Windows functions and can be used to distinguish
//between multiple instances of a given application.

//HINSTANCE	hPrevInstance 	The handle of the previous instance of this application. This value is NULL if this
//is the first instance.

//LPSTR 	lpCmdLine 	A far pointer to a null-terminated command-line. Specify this value when invoking the
//application from the program manager or from a call to WinExec.

//int	nCmdShow	An integer that specifies the application's window display. Pass this value to ShowWindow. 

//   hWnd = CreateWindow(
//   "Example",                 // See RegisterClass() call.

//   "Example _heapset 32 bit only",  // Text for window title bar.
//   WS_OVERLAPPEDWINDOW,        // Window style.
//   CW_USEDEFAULT,         // Default horizontal position.
//   CW_USEDEFAULT,          // Default vertical position.
//   CW_USEDEFAULT,            // Default width.
//   CW_USEDEFAULT,        // Default height.
//   NULL,                  // Overlapped windows have no parent.
//   NULL,                  // Use the window class menu.
//   NULL,              // This instance owns this window.
//
//   NULL                   // Pointer not needed.
//  );
//
  /* If window could not be created, return "failure" */

//  if (!hWnd)

  
  /* Make the window visible; update its client area; and return "success" */

//  ShowWindow(hWnd, 5); // Show the window
//  UpdateWindow(hWnd);     // Sends WM_PAINT message
//  return 1;
 return 1;
}

